/******************************************************************************

	    COPYRIGHT (c) 1988, 1998 by Globetrotter Software Inc.
	This software has been provided pursuant to a License Agreement
	containing restrictions on its use.  This software contains
	valuable trade secrets and proprietary information of 
	Globetrotter Software Inc and is protected by law.  It may 
	not be copied or distributed in any form or medium, disclosed 
	to third parties, reverse engineered or used in any manner not 
	provided for in said License Agreement except with the prior 
	written authorization from Globetrotter Software Inc.

/*****************************************************************************/
/*	
 *	Module:	lmflex.c v1.14.0.0
 *
 *	Description:	This is a sample application program, to illustrate 
 *			the use of the Flexible License Manager.
 *
 *	Last changed:  6/3/98
 *	D. Birns
 *
 */

#include <stdio.h>
#if (defined( __STDC__) || defined(_WINDOWS)) && !defined(apollo)
#include <stdlib.h>
#endif
#include <time.h>
#include "lmclient.h" 
#include "lm_attr.h"
#ifdef PC
#define LICPATH "license.dat;."
#else
#define LICPATH "@localhost:license.dat:."
#endif /* PC */
extern void user_crypt_filter();

#define FEATURE "f1"
VENDORCODE code;

main()
{
  char feature[MAX_FEATURE_LEN+1];
  LM_HANDLE *lm_job;


	if (lc_new_job((LM_HANDLE *)0, 0, &code, &lm_job))
	{
		lc_perror(lm_job, "lc_new_job failed");
		exit(lc_get_errno(lm_job));
	}

	printf("Enter feature to checkout [default: \"%s\"]: ", FEATURE);

	fgets(feature, MAX_FEATURE_LEN, stdin); 
	feature[strlen(feature)-1] = '\0'; /* truncate trailing newline */
	if (!*feature) strcpy(feature, FEATURE);


	lc_set_attr(lm_job, LM_A_USER_CRYPT_FILTER, user_crypt_filter);
	if (lc_checkout(lm_job, feature, "1.0", 1, LM_CO_NOWAIT, &code, 
								LM_DUP_NONE))
	{
		lc_perror(lm_job, "checkout failed");
		lc_free_job(lm_job);
		exit(lc_get_errno(lm_job));
	}
	printf("%s checked out...press return to exit...", feature); 
/*
 *	Wait till user hits return
 *	getchar may be interrupted by SIGALRM, so we loop if necessary
 */
	getchar();
	lc_checkin(lm_job, feature ,0);

	lc_free_job(lm_job);
        return(0);
}
